SystemOrganization addCategory: #'Pier-PictureLink'!

!PRVisitor methodsFor: '*pier-picturelink' stamp: 'kph 8/23/2007 12:56'!
visitPictureLink: anObject
	self visitFile: anObject.
	"self visitInternalLink: anObject."! !

!PRViewRenderer methodsFor: '*pier-picturelink' stamp: 'kph 8/23/2007 17:34'!
visitPictureLink: anObject
	| file url anchor |
	file := anObject file ifNil: [ ^ self ].
	url := file urlOn: html.
	
	anchor := html anchor.
	anObject target ifNotNil: [
		anchor	goto: (self context structure: anObject target)
	].
	anObject isInternal ifFalse: [
		anchor url: anObject reference
	].	
	anchor 
		class: 'picturelink';
	with: [ 
		html image
			class: (anObject isBroken ifTrue: [ 'broken' ] ifFalse: ['link']);
			url: url; 
			altText: (anObject tooltip ifNil: [ anObject title ])].

	! !

!PRIncomingReferences methodsFor: '*pier-picturelink' stamp: 'kph 8/23/2007 12:57'!
visitPictureLink: anObject
	(structures includes: anObject target)
		ifTrue: [ block value: anObject ]! !

!PROutgoingReferences methodsFor: '*pier-picturelink' stamp: 'kph 8/23/2007 12:58'!
visitPictureLink: anObject
	block value: anObject.
	(anObject target isNil or: [ structures includes: anObject target ])
		ifTrue: [ ^ self ].
	(continue value: anObject)
		ifTrue: [ self visit: anObject target ]! !

PRFile subclass: #PRPictureLink
	instanceVariableNames: 'linkUrl reference target tooltip isExternal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-PictureLink'!

!PRPictureLink class methodsFor: 'as yet unclassified' stamp: 'kph 8/3/2007 00:06'!
descriptionFile
	^ super descriptionFile
		label: 'Image File';
 		addCondition: [:v |  v isImage ] labelled: 'Image expected';
		yourself ! !

!PRPictureLink class methodsFor: 'as yet unclassified' stamp: 'kph 8/3/2007 00:04'!
descriptionLinkUrl
	^ MAStringDescription new
		selectorAccessor: #linkUrl;
		priority: 200;
		label: 'Link To Url';
		beEditable;
		yourself! !

!PRPictureLink class methodsFor: 'as yet unclassified' stamp: 'kph 8/23/2007 16:56'!
descriptionReference
	^ PRStructureDescription new
		selectorAccessor: #setReference;
		label: 'Reference';
		priority: 150;
		beEditable;
		yourself! !

!PRPictureLink class methodsFor: 'as yet unclassified' stamp: 'kph 8/3/2007 00:22'!
descriptionTooltip
	^ MAStringDescription new
		selectorAccessor: #tooltip;
		priority: 190;
		label: 'Tooltip';
		beEditable;
		yourself! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/2/2007 23:39'!
accept: aVisitor
	aVisitor visitPictureLink: self! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/23/2007 13:21'!
hasAlias
	^ false! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/23/2007 13:22'!
hasAnchor
	^ false! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 6/11/2008 17:32'!
isBroken

	self isInternal ifFalse: [ ^ false ].

	 (self reference notNil and: [ self target isNil ])
		ifTrue: [   self refresh ].
		
	^ self target isNil ! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/23/2007 13:56'!
isComponent

	^false
	! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/23/2007 13:16'!
isEmbedded

^ false! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 10/9/2007 09:27'!
isExternal
	"Answer the value of isExternal"

	^ isExternal! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 10/9/2007 09:27'!
isExternal: anObject
	"Set the value of isExternal"

	isExternal := anObject! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/23/2007 17:43'!
isInternal
	^ isExternal ~= true! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/23/2007 13:20'!
isLink

^ true! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 10/9/2007 09:27'!
linkUrl
	"Answer the value of linkUrl"

	^ linkUrl! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 10/9/2007 09:27'!
linkUrl: anObject
	"Set the value of linkUrl"

	linkUrl := anObject! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/23/2007 13:32'!
reference
	^ reference! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/23/2007 16:45'!
reference: anObject

 (anObject isKindOf: String) ifFalse: [ self halt ].
	reference := anObject! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/23/2007 16:54'!
refresh
	"This message will be sent by the structure whenever it is parsed and the references have to be set up. It simply starts a look-up in the owner using the reference-string. In case the reference is invalid the target will be set to ==nil== and the receiver is in a broken-state."

	self target: (PRPathLookup
		start: self 
		path: self reference
		onError: [ nil ])! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/23/2007 16:56'!
setReference
	^ reference! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 6/17/2008 16:55'!
setReference: anObject

	anObject ifNil: [ ^ self ].
	anObject isString ifTrue: [ self reference: anObject. self target: nil. isExternal := true ]
	ifFalse: [
		self target: anObject.
 	     self update
	].! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/2/2007 23:46'!
target
	"Answer the value of target"

	^ target! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/23/2007 17:25'!
target: anObject
	"Set the value of target"


	anObject ifNotNil: [ (anObject isKindOf: PRStructure) ifFalse: [ self halt ] ].
 
	target := anObject
	
! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/3/2007 00:21'!
tooltip
	"Answer the value of tooltip"

	^ tooltip! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/3/2007 00:21'!
tooltip: anObject
	"Set the value of tooltip"

	tooltip := anObject! !

!PRPictureLink methodsFor: 'accessing' stamp: 'kph 8/23/2007 16:53'!
update

	self reference: (PRPathReference
			from: self  
			to: self target)! !
